/* eslint no-cond-assign:0 */
'use strict';

// Import
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
const typeChecker = require('typechecker');

// Eachr
module.exports = function eachr(subject, callback) {
  // Handle
  if (typeChecker.isArray(subject)) {
    for (let key = 0; key < subject.length; ++key) {
      const value = subject[key];
      if (callback.call(subject, value, key, subject) === false) {
        break;
      }
    }
  } else if (typeChecker.isPlainObject(subject)) {
    for (const key in subject) {
      if (subject.hasOwnProperty(key)) {
        const value = subject[key];
        if (callback.call(subject, value, key, subject) === false) {
          break;
        }
      }
    }
  } else if (typeChecker.isMap(subject)) {
    const entries = subject.entries();
    let entry;
    while (entry = entries.next().value) {
      const _entry = entry,
        _entry2 = _slicedToArray(_entry, 2),
        key = _entry2[0],
        value = _entry2[1]; // destructuring
      if (callback.call(subject, value, key, subject) === false) {
        break;
      }
    }
  } else {
    // Perhaps falling back to a `for of` loop here would be sensible
    throw new Error('eachr does not know how to iterate what was passed to it');
  }

  // Return
  return subject;
};